
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class MessagesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const messages = await db.messages.create(
            {
                id: data.id || undefined,
        
        sender_type: data.sender_type
        ||
        null
            ,
            
        content: data.content
        ||
        null
            ,
            
        format: data.format
        ||
        null
            ,
            
        is_streaming: data.is_streaming
        ||
        false
        
            ,
            
        token_count: data.token_count
        ||
        null
            ,
            
        sent_at: data.sent_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await messages.setConversation( data.conversation || null, {
            transaction,
        });
        
        await messages.setSender_user( data.sender_user || null, {
            transaction,
        });
        
        await messages.setSender_agent( data.sender_agent || null, {
            transaction,
        });
        
        await messages.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        
        await messages.setAttachments(data.attachments || [], {
            transaction,
        });
        

        

        return messages;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const messagesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                sender_type: item.sender_type
            ||
            null
            ,
            
                content: item.content
            ||
            null
            ,
            
                format: item.format
            ||
            null
            ,
            
                is_streaming: item.is_streaming
            ||
            false
        
            ,
            
                token_count: item.token_count
            ||
            null
            ,
            
                sent_at: item.sent_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const messages = await db.messages.bulkCreate(messagesData, { transaction });

        // For each item created, replace relation files
        

        return messages;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const messages = await db.messages.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.sender_type !== undefined) updatePayload.sender_type = data.sender_type;
        
        
        if (data.content !== undefined) updatePayload.content = data.content;
        
        
        if (data.format !== undefined) updatePayload.format = data.format;
        
        
        if (data.is_streaming !== undefined) updatePayload.is_streaming = data.is_streaming;
        
        
        if (data.token_count !== undefined) updatePayload.token_count = data.token_count;
        
        
        if (data.sent_at !== undefined) updatePayload.sent_at = data.sent_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await messages.update(updatePayload, {transaction});

        
        
        if (data.conversation !== undefined) {
            await messages.setConversation(
              
              data.conversation,
              
              { transaction }
            );
        }
        
        if (data.sender_user !== undefined) {
            await messages.setSender_user(
              
              data.sender_user,
              
              { transaction }
            );
        }
        
        if (data.sender_agent !== undefined) {
            await messages.setSender_agent(
              
              data.sender_agent,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await messages.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        
        if (data.attachments !== undefined) {
            await messages.setAttachments(data.attachments, { transaction });
        }
        

        

        return messages;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const messages = await db.messages.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of messages) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of messages) {
                await record.destroy({transaction});
            }
        });


        return messages;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const messages = await db.messages.findByPk(id, options);

        await messages.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await messages.destroy({
            transaction
        });

        return messages;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const messages = await db.messages.findOne(
            { where },
            { transaction },
        );

        if (!messages) {
            return messages;
        }

        const output = messages.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.code_snippets_message = await messages.getCode_snippets_message({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.conversation = await messages.getConversation({
            transaction
        });
        
        
        output.sender_user = await messages.getSender_user({
            transaction
        });
        
        
        output.sender_agent = await messages.getSender_agent({
            transaction
        });
        
        
        output.attachments = await messages.getAttachments({
            transaction
        });
        
        
        output.organizations = await messages.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.conversations,
        as: 'conversation',
        
        where: filter.conversation ? {
          [Op.or]: [
            { id: { [Op.in]: filter.conversation.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.conversation.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'sender_user',
        
        where: filter.sender_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.sender_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.sender_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.ai_agents,
        as: 'sender_agent',
        
        where: filter.sender_agent ? {
          [Op.or]: [
            { id: { [Op.in]: filter.sender_agent.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.sender_agent.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },


      {
        model: db.message_attachments,
        as: 'attachments',
        required: false,
      },


    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.content) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'messages',
                        'content',
                        filter.content,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            sent_at: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    sent_at: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.token_countRange) {
                const [start, end] = filter.token_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    token_count: {
                    ...where.token_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    token_count: {
                    ...where.token_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.sent_atRange) {
                const [start, end] = filter.sent_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.sender_type) {
                where = {
                    ...where,
                sender_type: filter.sender_type,
            };
            }
            
            if (filter.format) {
                where = {
                    ...where,
                format: filter.format,
            };
            }
            
            if (filter.is_streaming) {
                where = {
                    ...where,
                is_streaming: filter.is_streaming,
            };
            }
            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      


      if (filter.attachments) {
        const searchTerms = filter.attachments.split('|');

        include = [
          {
            model: db.message_attachments,
            as: 'attachments_filter',
            required: searchTerms.length > 0,
            where: searchTerms.length > 0 ? {
              [Op.or]: [
                { id: { [Op.in]: searchTerms.map(term => Utils.uuid(term)) } },
                { 
                  caption: {
                    [Op.or]: searchTerms.map(term => ({ [Op.iLike]: `%${term}%` }))
                  }
                }
              ]
            } : undefined
          },
          ...include,
        ]
      }


            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.messages.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'messages',
                        'content',
                        query,
                    ),
                ],
            };
        }

        const records = await db.messages.findAll({
            attributes: [ 'id', 'content' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['content', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.content,
        }));
    }

    
};

